--
-- Specialization Motor
--
-- @author      Aluha74rus
-- @version     v0.1
-- @date          25/12/16

Motor = {};

function Motor.prerequisitesPresent(specializations)
    return true;
end;
function Motor:load(savegame)

    if self.isClient then
        local VibraciyaMotorIndex = getXMLString(self.xmlFile, "vehicle.DT75.VibraciyaMotor#index");
        if VibraciyaMotorIndex ~= nil then
            self.VibraciyaMotor = {};
            self.VibraciyaMotor.node = Utils.indexToObject(self.components, VibraciyaMotorIndex);
            self.VibraciyaMotor.maxRot = Utils.degToRad(Utils.getNoNil(getXMLFloat(self.xmlFile, "vehicle.DT75.VibraciyaMotor#maxRot"),0));
        end
        local KppVibraciyaIndex = getXMLString(self.xmlFile, "vehicle.DT75.KppVibraciya#index");
        if KppVibraciyaIndex ~= nil then
            self.KppVibraciya = {};
            self.KppVibraciya.node = Utils.indexToObject(self.components, KppVibraciyaIndex);
            self.KppVibraciya.maxRot = Utils.degToRad(Utils.getNoNil(getXMLFloat(self.xmlFile, "vehicle.DT75.KppVibraciya#maxRot"),0));
        end
    end
    
end
function Motor:delete()
end
function Motor:draw()
end
function Motor:mouseEvent(posX, posY, isDown, isUp, button)
end
function Motor:keyEvent(unicode, sym, modifier, isDown)
end
function Motor:update(dt)
end
function Motor:updateTick(dt)

    if self.isClient then
        if self:getIsMotorStarted() then
            if self.VibraciyaMotor ~= nil then
                local minRandom = -0.1;
                local maxRandom = 0.1;
                local angle = Utils.lerp(minRandom, maxRandom, math.random()) + self.VibraciyaMotor.maxRot * (self.motor:getEqualizedMotorRpm() / self.motor:getMaxRpm());
                angle = Utils.clamp(angle, 0, self.VibraciyaMotor.maxRot);
                setRotation(self.VibraciyaMotor.node, 0, 0, angle);
            end
            if self.KppVibraciya ~= nil then
                local minRandom = -0.1;
                local maxRandom = 0.1;
                local angle = Utils.lerp(minRandom, maxRandom, math.random()) + self.KppVibraciya.maxRot * (self.motor:getEqualizedMotorRpm() / self.motor:getMaxRpm());
                angle = Utils.clamp(angle, 0, self.KppVibraciya.maxRot);
                setRotation(self.KppVibraciya.node, 0, 0, angle);
            end
        end
    end
    
end
function Motor:stopMotor(noEventSend)
    
    if self.isClient then
        if self.VibraciyaMotor ~= nil then
            setRotation(self.VibraciyaMotor.node, 0, 0, 0);
        end
        if self.KppVibraciya ~= nil then
            setRotation(self.KppVibraciya.node, 0, 0, 0);
        end
    end
end